// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from bosch_locator_bridge:msg/ClientRecordingVisualization.idl
// generated code does not contain a copyright notice
#include "bosch_locator_bridge/msg/detail/client_recording_visualization__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `path_types`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
bosch_locator_bridge__msg__ClientRecordingVisualization__init(bosch_locator_bridge__msg__ClientRecordingVisualization * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    bosch_locator_bridge__msg__ClientRecordingVisualization__fini(msg);
    return false;
  }
  // visualization_id
  // status
  // distance_to_last_lc
  // delay
  // progress
  // path_types
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->path_types, 0)) {
    bosch_locator_bridge__msg__ClientRecordingVisualization__fini(msg);
    return false;
  }
  return true;
}

void
bosch_locator_bridge__msg__ClientRecordingVisualization__fini(bosch_locator_bridge__msg__ClientRecordingVisualization * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // visualization_id
  // status
  // distance_to_last_lc
  // delay
  // progress
  // path_types
  rosidl_runtime_c__int32__Sequence__fini(&msg->path_types);
}

bool
bosch_locator_bridge__msg__ClientRecordingVisualization__are_equal(const bosch_locator_bridge__msg__ClientRecordingVisualization * lhs, const bosch_locator_bridge__msg__ClientRecordingVisualization * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // visualization_id
  if (lhs->visualization_id != rhs->visualization_id) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // distance_to_last_lc
  if (lhs->distance_to_last_lc != rhs->distance_to_last_lc) {
    return false;
  }
  // delay
  if (lhs->delay != rhs->delay) {
    return false;
  }
  // progress
  if (lhs->progress != rhs->progress) {
    return false;
  }
  // path_types
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->path_types), &(rhs->path_types)))
  {
    return false;
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientRecordingVisualization__copy(
  const bosch_locator_bridge__msg__ClientRecordingVisualization * input,
  bosch_locator_bridge__msg__ClientRecordingVisualization * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // visualization_id
  output->visualization_id = input->visualization_id;
  // status
  output->status = input->status;
  // distance_to_last_lc
  output->distance_to_last_lc = input->distance_to_last_lc;
  // delay
  output->delay = input->delay;
  // progress
  output->progress = input->progress;
  // path_types
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->path_types), &(output->path_types)))
  {
    return false;
  }
  return true;
}

bosch_locator_bridge__msg__ClientRecordingVisualization *
bosch_locator_bridge__msg__ClientRecordingVisualization__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientRecordingVisualization * msg = (bosch_locator_bridge__msg__ClientRecordingVisualization *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientRecordingVisualization), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(bosch_locator_bridge__msg__ClientRecordingVisualization));
  bool success = bosch_locator_bridge__msg__ClientRecordingVisualization__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
bosch_locator_bridge__msg__ClientRecordingVisualization__destroy(bosch_locator_bridge__msg__ClientRecordingVisualization * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    bosch_locator_bridge__msg__ClientRecordingVisualization__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__init(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientRecordingVisualization * data = NULL;

  if (size) {
    data = (bosch_locator_bridge__msg__ClientRecordingVisualization *)allocator.zero_allocate(size, sizeof(bosch_locator_bridge__msg__ClientRecordingVisualization), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = bosch_locator_bridge__msg__ClientRecordingVisualization__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        bosch_locator_bridge__msg__ClientRecordingVisualization__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__fini(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      bosch_locator_bridge__msg__ClientRecordingVisualization__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence *
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array = (bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence *)allocator.allocate(sizeof(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__destroy(bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__are_equal(const bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * lhs, const bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientRecordingVisualization__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence__copy(
  const bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * input,
  bosch_locator_bridge__msg__ClientRecordingVisualization__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(bosch_locator_bridge__msg__ClientRecordingVisualization);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    bosch_locator_bridge__msg__ClientRecordingVisualization * data =
      (bosch_locator_bridge__msg__ClientRecordingVisualization *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!bosch_locator_bridge__msg__ClientRecordingVisualization__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          bosch_locator_bridge__msg__ClientRecordingVisualization__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!bosch_locator_bridge__msg__ClientRecordingVisualization__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
