// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientExpandMapOverwriteZoneInformation.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_OVERWRITE_ZONE_INFORMATION__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_OVERWRITE_ZONE_INFORMATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'polygon'
#include "geometry_msgs/msg/detail/point32__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientExpandMapOverwriteZoneInformation_
{
  using Type = ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>;

  explicit ClientExpandMapOverwriteZoneInformation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
      this->name = "";
      this->type = 0ll;
    }
  }

  explicit ClientExpandMapOverwriteZoneInformation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0ll;
      this->name = "";
      this->type = 0ll;
    }
  }

  // field types and members
  using _id_type =
    int64_t;
  _id_type id;
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _type_type =
    int64_t;
  _type_type type;
  using _polygon_type =
    std::vector<geometry_msgs::msg::Point32_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point32_<ContainerAllocator>>>;
  _polygon_type polygon;

  // setters for named parameter idiom
  Type & set__id(
    const int64_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__type(
    const int64_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__polygon(
    const std::vector<geometry_msgs::msg::Point32_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Point32_<ContainerAllocator>>> & _arg)
  {
    this->polygon = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t TYPE_ENFORCE =
    1;
  static constexpr int32_t TYPE_IGNORE =
    2;
  static constexpr int32_t TYPE_DELETE =
    3;

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientExpandMapOverwriteZoneInformation
    std::shared_ptr<bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientExpandMapOverwriteZoneInformation_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->name != other.name) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->polygon != other.polygon) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientExpandMapOverwriteZoneInformation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientExpandMapOverwriteZoneInformation_

// alias to use template instance with default allocator
using ClientExpandMapOverwriteZoneInformation =
  bosch_locator_bridge::msg::ClientExpandMapOverwriteZoneInformation_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>::TYPE_ENFORCE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>::TYPE_IGNORE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientExpandMapOverwriteZoneInformation_<ContainerAllocator>::TYPE_DELETE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_EXPAND_MAP_OVERWRITE_ZONE_INFORMATION__STRUCT_HPP_
