// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:msg/ClientMapVisualization.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_MAP_VISUALIZATION__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_MAP_VISUALIZATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__msg__ClientMapVisualization __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__msg__ClientMapVisualization __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClientMapVisualization_
{
  using Type = ClientMapVisualization_<ContainerAllocator>;

  explicit ClientMapVisualization_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visualization_id = 0ull;
      this->status = 0l;
      this->distance_to_last_lc = 0.0;
      this->delay = 0.0;
      this->progress = 0.0;
    }
  }

  explicit ClientMapVisualization_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->visualization_id = 0ull;
      this->status = 0l;
      this->distance_to_last_lc = 0.0;
      this->delay = 0.0;
      this->progress = 0.0;
    }
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _visualization_id_type =
    uint64_t;
  _visualization_id_type visualization_id;
  using _status_type =
    int32_t;
  _status_type status;
  using _distance_to_last_lc_type =
    double;
  _distance_to_last_lc_type distance_to_last_lc;
  using _delay_type =
    double;
  _delay_type delay;
  using _progress_type =
    double;
  _progress_type progress;
  using _path_types_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _path_types_type path_types;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__visualization_id(
    const uint64_t & _arg)
  {
    this->visualization_id = _arg;
    return *this;
  }
  Type & set__status(
    const int32_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__distance_to_last_lc(
    const double & _arg)
  {
    this->distance_to_last_lc = _arg;
    return *this;
  }
  Type & set__delay(
    const double & _arg)
  {
    this->delay = _arg;
    return *this;
  }
  Type & set__progress(
    const double & _arg)
  {
    this->progress = _arg;
    return *this;
  }
  Type & set__path_types(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->path_types = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t CLIENT_RECORDING_RECORDING_STATUS_STARTUP =
    -2;
  static constexpr int32_t CLIENT_RECORDING_RECORDING_STATUS_DELAYED =
    1;
  static constexpr int32_t CLIENT_RECORDING_RECORDING_STATUS_OK =
    2;
  static constexpr int32_t CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL =
    0;
  static constexpr int32_t CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE =
    1;
  static constexpr int32_t CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE =
    2;

  // pointer types
  using RawPtr =
    bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientMapVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__msg__ClientMapVisualization
    std::shared_ptr<bosch_locator_bridge::msg::ClientMapVisualization_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientMapVisualization_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->visualization_id != other.visualization_id) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->distance_to_last_lc != other.distance_to_last_lc) {
      return false;
    }
    if (this->delay != other.delay) {
      return false;
    }
    if (this->progress != other.progress) {
      return false;
    }
    if (this->path_types != other.path_types) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientMapVisualization_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientMapVisualization_

// alias to use template instance with default allocator
using ClientMapVisualization =
  bosch_locator_bridge::msg::ClientMapVisualization_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientMapVisualization_<ContainerAllocator>::CLIENT_RECORDING_RECORDING_STATUS_STARTUP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientMapVisualization_<ContainerAllocator>::CLIENT_RECORDING_RECORDING_STATUS_DELAYED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientMapVisualization_<ContainerAllocator>::CLIENT_RECORDING_RECORDING_STATUS_OK;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientMapVisualization_<ContainerAllocator>::CLIENT_RECORDING_PATH_TYPE_ENUM_NORMAL;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientMapVisualization_<ContainerAllocator>::CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLE_LOOP_CLOSURE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t ClientMapVisualization_<ContainerAllocator>::CLIENT_RECORDING_PATH_TYPE_ENUM_POSSIBLY_VISIBLE_LOOP_CLOSURE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__MSG__DETAIL__CLIENT_MAP_VISUALIZATION__STRUCT_HPP_
