// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from bosch_locator_bridge:srv/ClientMapStart.idl
// generated code does not contain a copyright notice

#ifndef BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__CLIENT_MAP_START__STRUCT_HPP_
#define BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__CLIENT_MAP_START__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Request __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Request __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClientMapStart_Request_
{
  using Type = ClientMapStart_Request_<ContainerAllocator>;

  explicit ClientMapStart_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_name = "";
      this->client_map_name = "";
    }
  }

  explicit ClientMapStart_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : recording_name(_alloc),
    client_map_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->recording_name = "";
      this->client_map_name = "";
    }
  }

  // field types and members
  using _recording_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _recording_name_type recording_name;
  using _client_map_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _client_map_name_type client_map_name;

  // setters for named parameter idiom
  Type & set__recording_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->recording_name = _arg;
    return *this;
  }
  Type & set__client_map_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->client_map_name = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Request
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Request
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientMapStart_Request_ & other) const
  {
    if (this->recording_name != other.recording_name) {
      return false;
    }
    if (this->client_map_name != other.client_map_name) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientMapStart_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientMapStart_Request_

// alias to use template instance with default allocator
using ClientMapStart_Request =
  bosch_locator_bridge::srv::ClientMapStart_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace bosch_locator_bridge


#ifndef _WIN32
# define DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Response __attribute__((deprecated))
#else
# define DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Response __declspec(deprecated)
#endif

namespace bosch_locator_bridge
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct ClientMapStart_Response_
{
  using Type = ClientMapStart_Response_<ContainerAllocator>;

  explicit ClientMapStart_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  explicit ClientMapStart_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->structure_needs_at_least_one_member = 0;
    }
  }

  // field types and members
  using _structure_needs_at_least_one_member_type =
    uint8_t;
  _structure_needs_at_least_one_member_type structure_needs_at_least_one_member;


  // constant declarations

  // pointer types
  using RawPtr =
    bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Response
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__bosch_locator_bridge__srv__ClientMapStart_Response
    std::shared_ptr<bosch_locator_bridge::srv::ClientMapStart_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClientMapStart_Response_ & other) const
  {
    if (this->structure_needs_at_least_one_member != other.structure_needs_at_least_one_member) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClientMapStart_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClientMapStart_Response_

// alias to use template instance with default allocator
using ClientMapStart_Response =
  bosch_locator_bridge::srv::ClientMapStart_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace bosch_locator_bridge

namespace bosch_locator_bridge
{

namespace srv
{

struct ClientMapStart
{
  using Request = bosch_locator_bridge::srv::ClientMapStart_Request;
  using Response = bosch_locator_bridge::srv::ClientMapStart_Response;
};

}  // namespace srv

}  // namespace bosch_locator_bridge

#endif  // BOSCH_LOCATOR_BRIDGE__SRV__DETAIL__CLIENT_MAP_START__STRUCT_HPP_
